package com.example.p2pchatapplication.adapters

import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import com.example.p2pchatapplication.databinding.UserItemBinding
import com.example.p2pchatapplication.adapters.ConversationsAdapter.ConversationsViewHolder
import com.example.p2pchatapplication.listeners.ConversationListener
import com.example.p2pchatapplication.models.Conversation

class ConversationsAdapter(private val conversations: List<Conversation>, private val conversationListener: ConversationListener) : RecyclerView.Adapter<ConversationsViewHolder>() {
    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ConversationsViewHolder {
        val userItemBinding =
            UserItemBinding.inflate(LayoutInflater.from(parent.context), parent, false)
        return ConversationsViewHolder(userItemBinding)
    }

    override fun onBindViewHolder(holder: ConversationsViewHolder, position: Int) {
        holder.setConversationData(conversations[position])
    }

    override fun getItemCount(): Int {
        return conversations.size
    }

    inner class ConversationsViewHolder(private var binding: UserItemBinding) : RecyclerView.ViewHolder(
        binding.root
    ) {
        fun setConversationData(conversation: Conversation) {
            binding.textUsername.text = conversation.username
            binding.imageProfile.text = conversation.username[0].uppercaseChar().toString()
            binding.root.setOnClickListener { conversationListener.onConversationClicked(conversation) }
        }
    }
}