package com.example.p2pchatapplication.adapters

import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import com.example.p2pchatapplication.adapters.UsersAdapter.UserViewHolder
import com.example.p2pchatapplication.databinding.UserItemBinding
import com.example.p2pchatapplication.listeners.UserListener
import com.example.p2pchatapplication.models.User

class UsersAdapter(private val users: MutableList<User>, private val userListener: UserListener) : RecyclerView.Adapter<UserViewHolder>() {
    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): UserViewHolder {
        val userItemBinding =
            UserItemBinding.inflate(LayoutInflater.from(parent.context), parent, false)
        return UserViewHolder(userItemBinding)
    }

    override fun onBindViewHolder(holder: UserViewHolder, position: Int) {
        holder.setUserData(users[position])
    }

    override fun getItemCount(): Int {
        return users.size
    }

    inner class UserViewHolder(private var binding: UserItemBinding) : RecyclerView.ViewHolder(
        binding.root
    ) {
        fun setUserData(user: User) {
            binding.textUsername.text = user.username
            binding.imageProfile.text = user.username!![0].uppercaseChar().toString()
            binding.root.setOnClickListener { _ -> userListener.onUserClicked(user) }
        }
    }
}
