package com.example.p2pchatapplication.database

import androidx.lifecycle.LiveData
import androidx.room.Dao
import androidx.room.Insert
import androidx.room.Query
import com.example.p2pchatapplication.models.ChatMessage

@Dao
interface ChatMessageDao {
    @Insert
    suspend fun insert(chatMessage: ChatMessage)

    /*
    @Query("SELECT * FROM chat_messages WHERE sender = :sender OR receiver = :receiver ORDER BY timestamp ASC")
    suspend fun getMessagesForChat(sender: String, receiver: String): List<ChatMessage>
    */

    @Query("SELECT * FROM chat_messages")
    fun getMessages(): LiveData<List<ChatMessage>>

    @Query("SELECT * FROM chat_messages WHERE conversationId = :conversationId")
    fun getMessagesForConversation(conversationId: String): LiveData<List<ChatMessage>>

    @Query("DELETE FROM chat_messages")
    suspend fun deleteAll()
}