package com.example.p2pchatapplication.database

import androidx.lifecycle.LiveData
import androidx.room.Dao
import androidx.room.Insert
import androidx.room.OnConflictStrategy
import androidx.room.Query
import com.example.p2pchatapplication.models.Conversation


@Dao
interface ConversationDao {
    @Insert(onConflict = OnConflictStrategy.REPLACE)
    suspend fun insert(conversation: Conversation): Long

    @Query("SELECT * FROM conversations")
    fun getConversations(): LiveData<List<Conversation>>

    @Query("SELECT * FROM conversations WHERE username = :username")
    suspend fun getConversation(username: String): Conversation

    @Query("DELETE FROM conversations")
    suspend fun deleteAll()
}