package com.example.p2pchatapplication.models

import androidx.room.Entity
import androidx.room.ForeignKey
import androidx.room.PrimaryKey

@Entity(tableName = "chat_messages",
        foreignKeys = [ForeignKey(
    entity = Conversation::class,
    parentColumns = ["username"],
    childColumns = ["conversationId"],
    onDelete = ForeignKey.CASCADE
)])

data class ChatMessage (
    @PrimaryKey(autoGenerate = true) val id: Long = 0,
    var conversationId: String? = null,
    var sender: String? = null,
    var receiver: String? = null,
    var message: String? = null,
    var timestamp: String? = null,
)