package com.example.p2pchatapplication.viewModel

import android.app.Application
import androidx.lifecycle.AndroidViewModel
import androidx.lifecycle.LiveData
import androidx.lifecycle.viewModelScope
import com.example.p2pchatapplication.database.ChatDatabase
import com.example.p2pchatapplication.database.ChatMessageDao
import com.example.p2pchatapplication.models.ChatMessage
import kotlinx.coroutines.launch

class ChatViewModel(application: Application) : AndroidViewModel(application) {
    private val chatMessageDao: ChatMessageDao = ChatDatabase.getDatabase(application).chatMessageDao()
    var chatMessages: LiveData<List<ChatMessage>> = chatMessageDao.getMessages()

    fun insert(chatMessage: ChatMessage) {
        viewModelScope.launch {
            chatMessageDao.insert(chatMessage)
        }
    }
}