package com.example.p2pchatapplication.viewModel

import android.app.Application
import androidx.lifecycle.AndroidViewModel
import androidx.lifecycle.LiveData
import androidx.lifecycle.viewModelScope
import com.example.p2pchatapplication.database.ChatDatabase
import com.example.p2pchatapplication.database.ConversationDao
import com.example.p2pchatapplication.models.Conversation
import kotlinx.coroutines.launch

class ConversationViewModel(application: Application) : AndroidViewModel(application) {
    private val conversationDao: ConversationDao = ChatDatabase.getDatabase(application).conversationDao()
    var conversations: LiveData<List<Conversation>> = conversationDao.getConversations()

    fun insert(conversation: Conversation) {
        viewModelScope.launch {
            conversationDao.insert(conversation)
        }
    }

}